/*
@@[ <t@C> @@<^CX^v32><CRC16>@@
<t@CoCi>
@@] <t@C> @@<^CX^v32><CRC16>@@

t@C
	Winłignorecaseň
	A[JCuɏdt@C͊i[Ȃ
	WJɏdt@Cꍇ͏㏑mF
	Ő󔒂͍폜
t@C8rbgCRC
t@CoCi
	oCi[hŊi[
A[JCuƒǉt@C͓łĂ͂ȂȂ
^CX^v̓^C][lH

tpX͊i[łȂ
	C:\dir\file
	..\dir\file
	\\host\name\dir\file
pX̂ƂmkdirȂ
fileƓmkdir͂łȂ
dirƓfile͂łȂ
arcfileœt@C͎włȂ
dstfile쐬srcfile󂵂Ă͂Ȃ
filȅ㏑mF
mkdirmF
oCi\r\r\n̈ꕔɂꌇꍇ
sR[hϊH
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <utime.h>
#include <time.h>
#include "crc.h"

#define HEAD_L	"@@[ "
#define HEAD_M	" @@"
#define HEAD_R	"@@"
#define TAIL_L	"@@] "
#define TAIL_M	" @@"
#define TAIL_R	"@@"
#ifdef _WIN32	//@@DOS?
#define NL		"\r\n"
#else
#define NL		"\n"
#endif

#define BUFSIZE	2048

struct element {
	struct element *next;
	char *fname;
	time_t modtime;
	unsigned short headcrc;
	int elepos;
	int elesize;
	int bodypos;
	int bodysize;
	unsigned short bodycrc;
	int binary;
};

int filecrc(FILE *fpi, char *fni, unsigned short *pcrc, int *pbin)
{
	char buf[BUFSIZE];
	int ret = 0, nread, bin = 0;
	unsigned short crc = 0;
	
	while (!feof(fpi)) {
		nread = fread(buf, 1, sizeof(buf), fpi);
		if (ferror(fpi)) {
			perror(fni);
			ret = -1;
			break;
		}
		if (nread == 0) {
			break;
		}
		ret += nread;
		crc = crc16(nread, buf, crc);
		if (memchr(buf, '\0', nread) != NULL) {
			bin |= 1;
		}
	}
	if (pcrc != NULL) {
		*pcrc = crc;
	}
	if (pbin != NULL) {
		*pbin = bin;
	}
	return ret;
}

unsigned long filemod(char *fname)
{
	struct stat buf;
	
#ifdef _WIN32
#define lstat	stat
#endif
	if (lstat(fname, &buf) < 0) {
		perror(fname);
		return 0;
	}
	return buf.st_mtime;
}

int bcopy(FILE *fpo, FILE *fpi, char *fno, char *fni, int size)
{
	char buf[BUFSIZE];
	int ret = 0, nread, nwrote;
	
	while (!feof(fpi)) {
		nread = fread(buf, 1, size < 0 ? sizeof(buf) : size < sizeof(buf) ? size : sizeof(buf), fpi);
		if (ferror(fpi)) {
			perror(fni);
			ret = -1;
			break;
		}
		if (size >= 0) {
			size -= nread;
		}
		if (nread == 0) {
			break;
		}
		nwrote = fwrite(buf, 1, nread, fpo);
		if (ferror(fpo)) {
			perror(fno);
			ret = -1;
			break;
		}
		if (nwrote != nread) {
			fprintf(stderr, "r/w size mismatch\n");
			ret = -1;
			break;
		}
		ret += nwrote;
	}
	return ret;
}

int print_ele(struct element *ele)
{
	struct tm tm;
	
	tm = *localtime(&ele->modtime);
	printf("%04d/%02d/%02d %02d:%02d %s%s %8ld %s\n",
		tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min,
		ele->headcrc != ele->bodycrc ? "*" : " ",
		ele->binary ? "b" : " ",
		ele->bodysize,
		ele->fname);
	return 0;
}

int ask_write(char *fname)
{
	struct stat buf;
	int c, yes = 0, no = 0;
	
	if (lstat(fname, &buf) == 0) {
		fprintf(stderr, "'%s' is exist.  Overwrite? ", fname);
		while ((c = getchar()) != EOF && c != '\n') {
			if (!yes && !no) {
				if (tolower(c) == 'y') {
					yes = 1;
				} else if (!isspace(c)) {
					no = 1;
				}
			}
		}
		return yes;
	}
	return 1;
}

int create(char *arc, char **files)
{
	FILE *fpo;
	int ret = 0, i;
	struct element ele;
	
	if (!ask_write(arc)) {
		return 0;
	}
	if ((fpo = fopen(arc, "wb")) != NULL) {
		for (i = 0; files[i] != NULL; i++) {
			FILE *fpi;
			
			ele.fname = files[i];
			ele.modtime = filemod(files[i]);
			if ((fpi = fopen(files[i], "rb")) != NULL) {
				if (filecrc(fpi, files[i], &ele.headcrc, &ele.binary) < 0) {
					ret = 1;
				}
				ele.bodycrc = ele.headcrc;
				rewind(fpi);
				fprintf(fpo, "%s%s%s%08lX%04lX%s" NL, HEAD_L, files[i], HEAD_M, ele.modtime, ele.headcrc, HEAD_R);
				ele.bodysize = bcopy(fpo, fpi, arc, files[i], -1);
				if (ele.bodysize < 0) {
					ret = 1;
				}
				fprintf(fpo, NL "%s%s%s%08lX%04lX%s" NL, TAIL_L, files[i], TAIL_M, ele.modtime, ele.headcrc, TAIL_R);
				fclose(fpi);
				print_ele(&ele);
			} else {
				perror(files[i]);
				ret = 1;
			}
		}
		fclose(fpo);
	} else {
		perror(arc);
		ret = 1;
	}
	return ret;
}

int ishead(char *line, unsigned int len, struct element *ele)
{
	char c, *head, *p;
	unsigned long modtime;
	unsigned long crc;
	int i;
	
	len -= line[len - 2] == '\r' ? 2 : 1;
	if (len < strlen(HEAD_L) + 1 + strlen(HEAD_M) + 12 + strlen(HEAD_R)
		|| memcmp(line, HEAD_L, strlen(HEAD_L)) != 0
		|| memchr(line, '\0', len) != NULL
		|| memcmp(line + len - strlen(HEAD_R), HEAD_R, strlen(HEAD_R)) != 0
		|| memcmp(line + len - (strlen(HEAD_R) + 12 + strlen(HEAD_M)), HEAD_M, strlen(HEAD_M)) != 0) {
		return 0;
	}
	p = line + len - strlen(HEAD_R);
	c = *p;
	*p = '\0';
	head = strdup(line + strlen(HEAD_L));
	*p = c;
	if (head == NULL) {
		perror("strdup");
		return 0;
	}
	modtime = 0;
	crc = 0;
	for (p = head + strlen(head) - 12, i = 0; i < 12 && isxdigit(p[i]); i++) {
		if (isdigit(p[i])) {
			c = p[i] - '0';
		} else {
			c = tolower(p[i]) - 'a' + 10;
		}
		if (i < 8) {
			modtime = (modtime << 4) | c;
		} else {
			crc = (crc << 4) | c;
		}
	}
	if (i < 12) {
		free(head);
		return 0;
	}
	p -= strlen(HEAD_M);
	*p = '\0';
	for (p--; p >= head && isspace(*p); p--) {
		*p = '\0';
	}
	for (p = head; isspace(*p); p++) {
	}
	if (strlen(p) == 0) {
		free(head);
		return 0;
	}
	if (ele != NULL) {
		ele->fname = strdup(p);
		ele->modtime = modtime;
		ele->headcrc = crc;
	}
	return 1;
}

int scan_arc(char *arc, struct element *list)
{
	FILE *fpi;
	enum { BEGIN, DUST_MID, DUST_LF, HEAD, BODY_MID, BODY_LF, TAIL } stat = BEGIN;
	int off = 0, ret = 0, pos = 0, nread, pos_begin, pos_end, lflen;
	char buf[BUFSIZE], *p, *q, *head = NULL;
	struct element ele;
	
	memset(&ele, 0, sizeof(ele));
	if ((fpi = fopen(arc, "rb")) != NULL) {
		while (!feof(fpi)) {
			nread = fread(buf + off, 1, sizeof(buf) - off, fpi);
			if (ferror(fpi)) {
				perror(arc);
				ret = -1;
				break;
			}
			off += nread;
			for (p = buf; p < buf + off; ) {
				switch (stat) {
				case BEGIN:
				case TAIL:
				case DUST_LF:
					if ((q = memchr(p, '\n', buf + off - p)) != NULL) {
						q++;
						if (ishead(p, q - p, &ele)) {
							stat = HEAD;
							*(q - (q[-2] == '\r' ? 2 : 1) - strlen(HEAD_R)) = '\0';
							head = strdup(p + strlen(HEAD_L));
							ele.elepos = pos + p - buf;
							ele.bodypos = pos + q - buf;
							ele.bodycrc = 0;
							ele.binary = 0;
						} else {
							stat = DUST_LF;
						}
						p = q;
					} else {
						stat = DUST_MID;
						p = buf + off;
					}
					break;
				case DUST_MID:
					if ((q = memchr(p, '\n', buf + off - p)) != NULL) {
						q++;
						stat = DUST_LF;
						p = q;
					} else {
						p = buf + off;
					}
					break;
				case HEAD:
				case BODY_LF:
					if ((q = memchr(p, '\n', buf + off - p)) != NULL) {
						q++;
						if (memcmp(p, TAIL_L, strlen(TAIL_L)) == 0
							&& memcmp(q - (q[-2] == '\r' ? 2 : 1) - strlen(TAIL_R), TAIL_R, strlen(TAIL_R)) == 0
							&& memcmp(p + strlen(TAIL_L), head, strlen(head)) == 0) {
							struct element *node, *parent;
							
							stat = TAIL;
							pos_end = pos + p - buf;
							ele.bodysize = pos_end - lflen - ele.bodypos;
							ele.elesize = pos + q - buf - ele.elepos;
							for (parent = list; parent->next != NULL; parent = parent->next) {
							}
							if ((node = malloc(sizeof(*node))) != NULL) {
								*node = ele;
								node ->next = NULL;
								parent->next = node;
							} else {
								ret = 1;
							}
							memset(&ele, 0, sizeof(ele));
							free(head);
							head = NULL;
						} else {
							if (stat == BODY_LF) {
								ele.bodycrc = crc16(lflen, lflen == 2 ? "\r\n" : "\n", ele.bodycrc);
							}
							stat = BODY_LF;
							lflen = q[-2] == '\r' ? 2 : 1;
							ele.bodycrc = crc16(q - lflen - p, p, ele.bodycrc);
							if (memchr(p, '\0', q - p) != NULL) {
								ele.binary |= 1;
							}
						}
						p = q;
					} else {
						if (stat == BODY_LF) {
							ele.bodycrc = crc16(lflen, lflen == 2 ? "\r\n" : "\n", ele.bodycrc);
						}
						stat = BODY_MID;
						ele.bodycrc = crc16(buf + off - p, p, ele.bodycrc);
						if (memchr(p, '\0', buf + off - p) != NULL) {
							ele.binary |= 1;
						}
						p = buf + off;
					}
					break;
				case BODY_MID:
					if ((q = memchr(p, '\n', buf + off - p)) != NULL) {
						q++;
						stat = BODY_LF;
						lflen = q[-2] == '\r' ? 2 : 1;
						ele.bodycrc = crc16(q - lflen - p, p, ele.bodycrc);
						p = q;
					} else {
						ele.bodycrc = crc16(buf + off - p, p, ele.bodycrc);
						p = buf + off;
					}
					break;
				default:
					break;
				}
				if (memchr(p, '\n', buf + off - p) == NULL) {
					memcpy(buf, p, buf + off - p);
					off -= p - buf;
					pos += p - buf;
					break;
				}
			}
			if (nread == 0) {
				break;
			}
		}
		if (head != NULL) {
			fprintf(stderr, "missing tail: %s\n", head);
			free(head);
		}
		fclose(fpi);
	}
	return ret;
}

int extract(struct element *list, char *arc, char **files)
{
	struct element *node;
	FILE *fpi;
	int ret = 0;
	time_t modtime;
	
	modtime = filemod(arc);
	if ((fpi = fopen(arc, "rb")) != NULL) {
		for (node = list->next; node != NULL; node = node->next) {
			FILE *fpo;
			
			print_ele(node);
			if (!ask_write(node->fname)) {
				continue;
			}
			if ((fpo = fopen(node->fname, "wb")) != NULL) {
				struct utimbuf buf;
				
				if (fseek(fpi, node->bodypos, SEEK_SET) < 0) {
					perror(arc);
					ret = 1;
				}
				if (bcopy(fpo, fpi, node->fname, arc, node->bodysize) < 0) {
					ret = 1;
				}
				fclose(fpo);
				if (node->headcrc == node->bodycrc && node->modtime != 0) {
					buf.actime = node->modtime;
					buf.modtime = node->modtime;
				} else {
					buf.actime = modtime;
					buf.modtime = modtime;
				}
				if (utime(node->fname, &buf) < 0) {
					perror(node->fname);
					ret = 1;
				}
			} else {
				perror(node->fname);
				ret = 1;
			}
		}
		fclose(fpi);
	} else {
		perror(arc);
		ret = 1;
	}
	return ret;
}

int print_list(struct element *list)
{
	struct element *node;
	
	for (node = list->next; node != NULL; node = node->next) {
		print_ele(node);
	}
	return 0;
}

void free_list(struct element *list)
{
	struct element *node, *next;
	
	for (node = list->next; node != NULL; node = next) {
		next = node->next;
		if (node->fname != NULL) {
			free(node->fname);
		}
		free(node);
	}
}

int main(int argc, char **argv)
{
	int i, ret = 0;
	enum { CMD_NONE, CMD_CRE, CMD_EXT, CMD_LIST } cmd = CMD_NONE;
	char *arc = NULL, **files = NULL;
	struct element list;
	
	memset(&list, 0, sizeof(list));
	for (i = 1; i < argc; i++) {
		if (i == 1 && strcmp(argv[i], "c") == 0) {
			cmd = CMD_CRE;
		} else if (i == 1 && strcmp(argv[i], "x") == 0) {
			cmd = CMD_EXT;
		} else if (i == 1 && strcmp(argv[i], "t") == 0) {
			cmd = CMD_LIST;
		} else if (cmd != CMD_NONE) {
			if (arc == NULL) {
				arc = argv[i];
			} else if (files == NULL) {
				files = argv + i;
			} else {
			}
		} else {
usage:
			fprintf(stderr, "usage: %s {c|x|t} archive files...\n", argv[0]);
			return 1;
		}
	}
	if (cmd == CMD_NONE || arc == NULL || cmd == CMD_CRE && files == NULL) {
		goto usage;
	}
	switch (cmd) {
	case CMD_CRE:
		ret = create(arc, files);
		break;
	case CMD_EXT:
		if ((ret = scan_arc(arc, &list)) == 0) {
			ret = extract(&list, arc, files);
		}
		free_list(&list);
		break;
	case CMD_LIST:
		if ((ret = scan_arc(arc, &list)) == 0) {
			ret = print_list(&list);
		}
		free_list(&list);
		break;
	case CMD_NONE:
	default:
		break;
	}
	return ret;
}

