#include <limits.h>
#include "crc.h"

#define CRCPOLY2	0x8408U
static unsigned short crctable[UCHAR_MAX + 1];
static int init = 0;

static void initcrc(void)
{
	unsigned short i, j, r;

	for (i = 0; i <= UCHAR_MAX; i++) {
		r = i;
		for (j = 0; j < CHAR_BIT; j++)
			if (r & 1)
				r = (r >> 1) ^ CRCPOLY2;
			else
				r >>= 1;
		crctable[i] = r;
	}
	init = 1;
}

unsigned short crc16(int n, unsigned char *c, unsigned short last)
{
	unsigned short r;

//printf("crc size=%d\n", n);
	if (!init)
		initcrc();
	r = last ^ 0xffffU;
	while (0 <= --n)
		r = (r >> CHAR_BIT) ^ crctable[(unsigned char)r ^ *c++];
	return r ^ 0xffffU;
}

